﻿
Public Class Form1

    Friend VideoMode As VideoModes = VideoModes.Normal
    Friend NormalLocation As Point
    Friend LargeLocation As Point
    Friend NormalSize As Size
    Friend LargeSize As Size
    Friend MediaFiles_Index As Int32
    Private MediaType As String
    Private Slot_Start As Int32

    Private EventsAreEnabled As Boolean = False
    Private ScreenAspectRatio As Single

    Friend Enum VideoModes As Int32
        Normal = 1
        Large = 2
        FullScreen = 3
    End Enum

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim s As String
        s = IO.Path.GetFileNameWithoutExtension(Application.StartupPath)
        If s.ToLower = "bin" Then
            s = IO.Path.GetFileNameWithoutExtension(IO.Directory.GetParent(Application.StartupPath).ToString)
        End If
        Text = AppTitleAndVersion("Theremino Media Player")
        Me.Text &= "  ( " & s & " )"
        ScreenAspectRatio = CSng(Screen.PrimaryScreen.Bounds.Width / Screen.PrimaryScreen.Bounds.Height)
        ToolTips_Init()
        Load_INI()

        WMP_Init()
        'Application.AddMessageFilter(New IgnoreMouseClickMessageFilter(Me, WMP))
        Application.AddMessageFilter(New MouseEvents_MessageFilter(Me, Panel1))

        SetVideoMode(VideoMode)

        Timer100Hz.Interval = 10
        Timer100Hz.Start()
        Timer5Hz.Interval = 200
        Timer5Hz.Start()

        EventsAreEnabled = True
        Slot_Start = txt_SlotStart.NumericValueInteger

        OpenMediaFile(MediaFiles_Index)
        PreparePanelsForVideo()
        WMP.Ctlcontrols.stop()
        EventsAreEnabled = True
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        Save_INI()
        ShowCursor()
        ShowTrayWnd()
    End Sub


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 500
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        'ttp1.SetToolTip(txt_SlotStart, _
        '                "Video Position ( input )" & vbCr & _
        '                "-------------------------------------" & vbCr & _
        '                "The video position is controlled" & vbCr & _
        '                "by this slot with a float value " & vbCr & _
        '                "from 0.0 to 1000.0.")

        'ttp1.SetToolTip(txt_SlotChange1, _
        '                "Video File Change ( input )" & vbCr & _
        '                "-------------------------------------" & vbCr & _
        '                "The current video file is changed" & vbCr & _
        '                "by a file index on this slot.")

        'ttp1.SetToolTip(txt_SlotIn2, _
        '                "Video Position ( input )" & vbCr & _
        '                "-------------------------------------" & vbCr & _
        '                "The video position is controlled" & vbCr & _
        '                "by this slot with a float value " & vbCr & _
        '                "from 0.0 to 1000.0.")

        'ttp1.SetToolTip(txt_SlotChange2, _
        '                "Video File Change ( input )" & vbCr & _
        '                "-------------------------------------" & vbCr & _
        '                "The current video file is changed" & vbCr & _
        '                "by a file index on this slot.")

    End Sub

    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub Tooltips_MouseEnter(ByVal sender As Object, _
                                    ByVal e As System.EventArgs) Handles txt_SlotStart.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub



    ' ==============================================================================================================
    '  CURSOR TIMED HIDE  -  4 to 15 uS
    ' ==============================================================================================================
    Private HideTimer As Stopwatch = New Stopwatch
    Private HideCursor_OldPos As Point = New Point(-99999, -99999)
    Private Sub Cursor_TimedHide()
        'Dim sw1 As Stopwatch = New Stopwatch
        'sw1.Reset()
        'sw1.Start()
        If VideoMode = VideoModes.Normal Then
            ShowCursor()
        Else
            If HideTimer.ElapsedMilliseconds < 3000 Then
                ShowCursor()
            Else
                HideCursor()
            End If
        End If
        If Cursor.Position <> HideCursor_OldPos Then
            HideCursor_OldPos = Cursor.Position
            ShowCursor()
            HideTimer.Reset()
            HideTimer.Start()
        End If
        'Text = (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0")
    End Sub


    ' ==============================================================================================================
    '   HIDE SHOW CURSOR  ( BlankCursor for MONO - LINUX )
    ' ==============================================================================================================
    Private BlankCursor As Cursor = New Cursor(New IO.MemoryStream(My.Resources.BlankCursor))
    Private CursorVisible As Boolean = True
    Friend Sub HideCursor()
        If CursorVisible Then
            CursorVisible = False
            Cursor.Hide()
            Cursor = BlankCursor
        End If
    End Sub
    Friend Sub ShowCursor()
        If Not CursorVisible Then
            CursorVisible = True
            Cursor.Show()
            Cursor = Cursors.Default
        End If
    End Sub


    ' ===================================================================================================
    '  ContextMenuStrip
    ' ===================================================================================================
    Friend Sub ExecRbuttonUp()
        ContextMenuStrip1.Show(Panel1, Me.PointToClient(Cursor.Position))
        LimitFormPosition(Me)
        StopFormMove()
        Save_INI()
    End Sub
    Private Sub CloseProgramToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseProgramToolStripMenuItem.Click
        Me.Close()
    End Sub


    ' ===================================================================================================
    '  Form Move and Resize
    ' ===================================================================================================
    Private CorrectAspectRatio As Boolean = False

    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        If Not EventsAreEnabled Then Return
        If WindowState = FormWindowState.Minimized Then Return
        If VideoMode = VideoModes.FullScreen Then Return
        Save_INI()
    End Sub

    Private Sub Form1_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        If Not EventsAreEnabled Then Return
        CorrectFormSize()
        Save_INI()
    End Sub

    Private Sub Form1_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not EventsAreEnabled Then Return
        HideOrShowTrayWnd()
    End Sub

    Private Sub CorrectFormSize()
        LimitFormPosition(Me)
        Select Case VideoMode
            Case VideoModes.Normal
                If CorrectAspectRatio Then
                    If Math.Abs(Width - NormalSize.Width) <= Math.Abs(Height - NormalSize.Height) Then
                        Width = CInt((Height - 100) * ScreenAspectRatio)
                    Else
                        Height = 110 + CInt(Width / ScreenAspectRatio)
                    End If
                End If
                NormalLocation = Me.Location
                NormalSize = Me.Size
            Case VideoModes.Large
                If CorrectAspectRatio Then
                    If Math.Abs(Width - LargeSize.Width) <= Math.Abs(Height - LargeSize.Height) Then
                        Width = CInt(Height * ScreenAspectRatio)
                    Else
                        Height = CInt(Width / ScreenAspectRatio)
                    End If
                End If
                LargeLocation = Me.Location
                LargeSize = Me.Size
        End Select
    End Sub

    ' ==========================================================================================================
    '   MOUSE-WHEEL - RESIZE WINDOW
    ' ==========================================================================================================
    Friend Sub ExecMouseWheel(ByVal delta As Int32)
        If WindowState <> FormWindowState.Normal Then Return
        If VideoMode = VideoModes.FullScreen Then Return
        Timer100Hz.Stop()
        EventsAreEnabled = False
        If My.Computer.Keyboard.CtrlKeyDown Then
            CorrectAspectRatio = False
            Me.Size = Size.Add(Me.Size, New Size(delta \ 64, 0))
        ElseIf My.Computer.Keyboard.ShiftKeyDown Then
            CorrectAspectRatio = False
            Me.Size = Size.Add(Me.Size, New Size(0, delta \ 64))
        Else
            CorrectAspectRatio = True
            Me.Size = Size.Add(Me.Size, New Size(0, delta \ 32))
        End If
        CorrectFormSize()
        EventsAreEnabled = True
        Timer100Hz.Start()
        HideOrShowTrayWnd()
        Save_INI()
    End Sub

    ' ==========================================================================================================
    '  MOVE BY MOUSE
    ' ==========================================================================================================
    Private CursorStartPos As Point
    Private FormStartPos As Point = New Point(-9999, 0)
    Private Sub StartFormMove()
        CursorStartPos = Cursor.Position
        FormStartPos = Me.Location
    End Sub
    Private Sub StopFormMove()
        FormStartPos.X = -9999
        Select Case VideoMode
            Case VideoModes.Normal
                NormalLocation = Me.Location
            Case VideoModes.Large
                LargeLocation = Me.Location
        End Select
    End Sub
    Private Sub ContinueFormMove()
        If FormStartPos.X < -9000 Then Return
        If WindowState <> FormWindowState.Normal Then Return
        If VideoMode = VideoModes.FullScreen Then Return
        Me.Location = New Point(FormStartPos.X + Cursor.Position.X - CursorStartPos.X, _
                                FormStartPos.Y + Cursor.Position.Y - CursorStartPos.Y)
    End Sub
    Friend Sub ExecLButtonMove()
        ContinueFormMove()
        Panel1.Focus()
    End Sub
    Friend Sub ExecLButtonDown()
        StartFormMove()
    End Sub

    ' ==========================================================================================================
    '  VideoModes - NORMAL / LARGE / FULL SCREEN
    ' ==========================================================================================================
    Friend Sub ChangeVideoMode()
        If WindowState = FormWindowState.Maximized And FormBorderStyle <> FormBorderStyle.None Then
            SetVideoMode(VideoModes.Normal)
        Else
            Select Case VideoMode
                Case VideoModes.Normal : SetVideoMode(VideoModes.Large)
                Case VideoModes.Large : SetVideoMode(VideoModes.FullScreen)
                Case VideoModes.FullScreen : SetVideoMode(VideoModes.Normal)
                Case Else : SetVideoMode(VideoModes.Normal)
            End Select
        End If
        Save_INI()
        WMP.Select()
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If e.KeyCode = Keys.Escape Then
            SetVideoMode(VideoModes.Normal)
        End If
    End Sub

    Private Sub SetVideoMode(ByVal vmode As VideoModes)
        '
        EventsAreEnabled = False
        '
        If vmode <> VideoMode Then
            Select Case VideoMode
                Case VideoModes.Normal
                    If WindowState = FormWindowState.Normal Then
                        NormalLocation = Me.Location
                        NormalSize = Me.Size
                    End If
                Case VideoModes.Large
                    LargeLocation = Me.Location
                    LargeSize = Me.Size
            End Select
        End If
        '
        Me.Visible = False
        '
        WindowState = FormWindowState.Normal
        VideoMode = vmode
        '
        If VideoMode = VideoModes.Normal Then
            GroupBox2.Visible = True
        Else
            GroupBox2.Visible = False
        End If
        '
        Select Case VideoMode
            Case VideoModes.Normal
                ShowTrayWnd()
                Me.MinimumSize = New Size(600, 400)
                FormBorderStyle = FormBorderStyle.Sizable
                Me.Location = NormalLocation
                Me.Size = NormalSize
                Panel1.Location = New Point(4, 4)
                ' ------------------------------------- test if Major>5 (not XP)
                If Environment.OSVersion.Version.Major > 5 Then
                    Panel1.Size = Size.Subtract(Me.ClientSize, New Size(8, 84))
                Else
                    Panel1.Size = Size.Subtract(Me.Size, New Size(16, 112))
                End If
                LimitFormPosition(Me)
            Case VideoModes.Large
                Me.MinimumSize = New Size(64, 64)
                FormBorderStyle = FormBorderStyle.None
                Me.Location = LargeLocation
                Me.Size = LargeSize
                HideOrShowTrayWnd()
                Panel1.Location = New Point(0, 0)
                Panel1.Size = Me.Size
                LimitFormPosition(Me)
            Case VideoModes.FullScreen
                Me.MinimumSize = New Size(64, 64)
                FormBorderStyle = FormBorderStyle.None
                Dim r As Rectangle = Screen.GetBounds(Me.Location)
                Me.Location = r.Location
                Me.Size = r.Size
                HideOrShowTrayWnd()
                Panel1.Location = New Point(0, 0)
                Panel1.Size = Me.Size
        End Select

        EventsAreEnabled = True
        Me.Visible = True
    End Sub

    Private Sub HideOrShowTrayWnd()
        If VideoMode <> VideoModes.Large And VideoMode <> VideoModes.FullScreen Then Return
        If Me.Bottom > Screen.PrimaryScreen.WorkingArea.Height - 2 And _
           Me.Left < Screen.PrimaryScreen.WorkingArea.Width Then
            HideTrayWnd()
        Else
            ShowTrayWnd()
        End If
    End Sub



    ' ================================================================================================
    '    TIMERS
    ' ================================================================================================
    Private Sub Timer100Hz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer100Hz.Tick
        If Not EventsAreEnabled Then Return

        ' ------------------------------------------------- this invisibilize WMP when not playing
        'If WMP.Ctlcontrols.currentPosition <> 0 Then
        '    WMP.Visible = True
        'Else
        '    WMP.Visible = False
        'End If

        Static OldStartValue As Single = 0
        If Slot_Start >= 0 Then
            Dim n As Single = Slots.ReadSlot_NoNan(Slot_Start)
            If n >= 500 Then
                If OldStartValue < 500 Then
                    OldStartValue = n
                    If chk_Change.Checked Then
                        MediaFiles_Index += 1
                        If MediaFiles_Index >= MediaFileNames.Length Then
                            MediaFiles_Index = 0
                        End If
                    End If
                    OpenMediaFile(MediaFiles_Index)
                    Me.TopMost = True
                    Me.TopMost = False
                End If
            Else
                If Not chk_Trigger.Checked Then
                    WMP.Ctlcontrols.stop()
                End If
            End If
            OldStartValue = n
        End If
        '
        If chk_Repeat.Checked Then
            If MediaType = "IMAGE" Then
                WMP.Ctlcontrols.currentPosition = 0
            Else
                If WMP.playState = WMPLib.WMPPlayState.wmppsStopped Then
                    WMP.Ctlcontrols.play()
                End If
            End If
        End If

    End Sub

    Private Sub Timer5Hz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer5Hz.Tick
        If Not EventsAreEnabled Then Return
        Cursor_TimedHide()
    End Sub


    ' ================================================================================================
    '   SAVE INI ON LOST-FOCUS
    ' ================================================================================================
    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles txt_SlotStart.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub



    ' ================================================================================================
    '   SET PROPERTIES
    ' ================================================================================================
    Private Sub txt_SlotStart_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotStart.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Slot_Start = txt_SlotStart.NumericValueInteger
        Save_INI()
    End Sub



    ' =======================================================================================
    '   COMBO VIDEO FILES
    ' =======================================================================================
    Private Sub cmb_MediaFiles_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_MediaFiles.DropDown
        ReadMediaFileNames_Sorted()
        If MediaFileNames Is Nothing Then Return
        cmb_MediaFiles.Items.Clear()
        For Each f As String In MediaFileNames
            cmb_MediaFiles.Items.Add(My.Computer.FileSystem.GetName(f))
        Next
        cmb_MediaFiles.SelectedIndex = MediaFiles_Index
    End Sub
    Private Sub cmb_MediaFiles_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_MediaFiles.SelectionChangeCommitted
        OpenMediaFile(cmb_MediaFiles.SelectedIndex)
        Save_INI()
    End Sub


    ' ==========================================================================================================
    '  OPEN VIDEO FILE
    ' ==========================================================================================================
    Private Sub OpenMediaFile(ByVal numFile As Int32)
        Timer100Hz.Stop()
        ReadMediaFileNames_Sorted()
        If MediaFileNames Is Nothing Then Timer100Hz.Start() : Return
        If MediaFileNames.Length < 1 Then Timer100Hz.Start() : Return
        If MediaFiles_Index < 0 Then MediaFiles_Index = 0
        MediaFiles_Index = numFile Mod MediaFileNames.Length
        Dim s As String = MediaFileNames(MediaFiles_Index)
        Combo_Init(cmb_MediaFiles, My.Computer.FileSystem.GetName(s))
        Timer100Hz.Start()
        Load_Media(My.Computer.FileSystem.GetName(s))
    End Sub


    ' ==========================================================================================================
    '  WMP
    ' ==========================================================================================================
    Private Delegate Sub Load_Media_Delegate(ByVal filename As String)
    Private Sub Load_Media(ByVal filename As String)
        If InvokeRequired Then
            ' ------------------------------------ wait the command execution with "Invoke" (not "BeginInvoke")
            Invoke(New Load_Media_Delegate(AddressOf Load_Media), filename)
        Else
            Dim fullPath As String
            Select Case Strings.Right(filename, 4).ToLower
                Case ".jpg", ".bmp"
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & filename)
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        ' --------------------------------------------------
                        'PictureBox1.Image = Image.FromFile(fullPath)
                        'PreparePanelsForImages()
                        ' --------------------------------------------------
                        MediaType = "IMAGE"
                        WMP.URL = fullPath
                        WMP.settings.autoStart = True
                        WMP_WaitReady()
                        'PreparePanelsForVideo()
                        WMP.Ctlcontrols.play()
                    End If
                Case ".avi", ".wmv", ".mpg", ".mp4", ".mov", ".gif"
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & filename)
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        MediaType = "VIDEO"
                        WMP.URL = fullPath
                        WMP_WaitReady()
                        'PreparePanelsForVideo()
                        WMP.Ctlcontrols.play()
                    End If
                Case ".mp3", ".wav"
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & filename)
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        MediaType = "SOUND"
                        WMP.Hide()
                        WMP.URL = fullPath
                        WMP_WaitReady()
                    End If
            End Select
        End If
    End Sub
    Private Sub WMP_WaitReady()
        Do
            Application.DoEvents()
        Loop Until WMP.playState <> WMPLib.WMPPlayState.wmppsTransitioning
    End Sub
    Private Sub WMP_Init()
        WMP.Dock = DockStyle.Fill
        WMP.stretchToFit = True
        WMP.enableContextMenu = False
        WMP.uiMode = "none"
        WMP.Visible = False
    End Sub
    Private Sub PreparePanelsForImages()
        'GroupBox2.BackgroundImageLayout = ImageLayout.Stretch
        'GroupBox2.BackColor = Color.White
        WMP.Visible = False
        'PictureBox1.Left = 2
        'PictureBox1.Top = 16
        'If PictureBox1.Size.Width < GroupBox2.ClientSize.Width - 20 Then
        '    PictureBox1.Width = GroupBox2.ClientSize.Width - 4
        '    PictureBox1.Height = GroupBox2.ClientSize.Height - 16
        'End If
        'PictureBox1.Visible = True
    End Sub
    Private Sub PreparePanelsForVideo()
        'GroupBox2.BackgroundImage = Nothing
        'GroupBox2.BackColor = Color_Panels
        'PictureBox1.Visible = False
        WMP.stretchToFit = True
        WMP.Left = 0
        WMP.Top = 0
        If WMP.Size.Width < GroupBox2.ClientSize.Width - 20 Then
            WMP.Size = GroupBox2.ClientSize
        End If
        WMP.Visible = True
    End Sub

End Class